#include "inc/main.h"


CHANNEL *CHANNEL::chan_list = NULL;
DEVICE *DEVICE::dev_list = NULL;

DEVICE::~DEVICE()
{
    CHANNEL *ch, *ch_next=chan_list;
    while ((ch = ch_next))
    {
	ch_next = ch->chan_next_same_dev;
	delete ch;
    }

    DEVICE *dev = dev_list;
    if (dev==this) dev_list = dev_next;
    else
    {
	while (dev && dev->dev_next && dev->dev_next != this) dev = dev->dev_next;
	if (dev) dev->dev_next = dev_next;
    }
}

void DEVICE::RegChannel(CHANNEL *chan)
{
    chan->chan_next_same_dev = chan_list;
    chan_list = chan;

    openChannels++;
//    cout << "Registered\t" << chan->name << " on " << type << "(" << ext << ") : "<<toStr(openChannels)<<endl;
}


void DEVICE::UnregChannel(CHANNEL *chan)
{
    openChannels--;
//    cout << "Unregistered\t" << chan->name << " from " << name<< " : "<<toStr(openChannels)<<endl;
    CHANNEL *ch = chan_list;

    if (ch == chan) chan_list = chan->chan_next_same_dev;
    else
    {
	while (ch && ch->chan_next_same_dev && ch->chan_next_same_dev != chan)
	    ch = ch->chan_next_same_dev;

	if (ch) ch->chan_next_same_dev = chan->chan_next_same_dev;
    }
}

